#ifndef PULSEVIEW_H
#define PULSEVIEW_H

#include <View.h>
#include "progressbar.h"
#include "Mlm78.h"

const int TEMP_WIDTH = 28;
const int FAN_WIDTH=46;
const int PROGRESS_HEIGHT	= 15;

class _EXPORT TPulseView : public BView {
	public:
		TPulseView (BMessage *archive)
			: BView(archive)
		{
			do_init();
		}
		TPulseView (BRect r)
			: BView(r, "MiniPulse", B_FOLLOW_NONE, B_WILL_DRAW | B_PULSE_NEEDED)
		{
			do_init();
		}
		virtual ~TPulseView()
		{	delete [] fCPUs;
			delete sensor;
		}
		void do_init ();
		virtual status_t Archive(BMessage *data, bool deep = true) const; 
		static BArchivable* Instantiate(BMessage *data);
		
		virtual void AttachedToWindow();
		virtual void Pulse();
		
		virtual	void Draw (BRect);
		virtual void MessageReceived (BMessage *message);	
		
	private:
		virtual void DrawTemps();
		virtual void DrawFans();
		virtual void DrawVolts();
		
		int numCPUs;
		TProgressBar	**fCPUs;		
		bigtime_t lastUpdateTime;
		
		int count;
		Mlm78 *sensor;
};

#endif // PULSEVIEW_H
